## GSocketControlMessage GSocketControlMessage — A GSocket control message |

## Functions

GSocketControlMessage * | g_socket_control_message_deserialize ()
int | g_socket_control_message_get_level ()
int | g_socket_control_message_get_msg_type ()
gsize | g_socket_control_message_get_size ()
void | g_socket_control_message_serialize ()

## Types and Values

| GSocketControlMessage

## Object Hierarchy

        GObject
        ╰── GSocketControlMessage
            ├── GUnixFDMessage
            ╰── GUnixCredentialsMessage

## Includes

    #include <gio/gio.h>

## Description

A GSocketControlMessage is a special-purpose utility message that can be sent to or received from a GSocket. These types of messages are often called "ancillary data".

The message can represent some sort of special instruction to or information from the socket or can represent a special kind of transfer to the peer (for example, sending a file descriptor over a UNIX socket).

These messages are sent with `g_socket_send_message()` and received with `g_socket_receive_message()`.

To extend the set of control message that can be sent, subclass this class and override the get_size, get_level, get_type and serialize methods.

To extend the set of control messages that can be received, subclass this class and implement the deserialize method. Also, make sure your class is registered with the GType typesystem before calling `g_socket_receive_message()` to read such a message.

## Functions

### g_socket_control_message_deserialize ()

    GSocketControlMessage *
    g_socket_control_message_deserialize (int level,
                                          int type,
                                          gsize size,
                                          gpointer data);

Tries to deserialize a socket control message of a given `level` and `type` . This will ask all known (to GType) subclasses of GSocketControlMessage if they can understand this kind of message and if so deserialize it into a GSocketControlMessage.

If there is no implementation for this kind of control message, `NULL` will be returned.

#### Parameters

level | a socket level |
type | a socket control message type for the given `level` |
size | the size of the data in bytes |
data | pointer to the message data. | [array length=size][element-type guint8]

#### Returns

the deserialized message or `NULL`.

[transfer full]

Since 2.22

### g_socket_control_message_get_level ()

    int
    g_socket_control_message_get_level (GSocketControlMessage *message);

Returns the "level" (i.e. the originating protocol) of the control message. This is often SOL_SOCKET.

#### Parameters

message | a GSocketControlMessage |

#### Returns

an integer describing the level

Since 2.22

### g_socket_control_message_get_msg_type ()

    int
    g_socket_control_message_get_msg_type (GSocketControlMessage *message);

Returns the protocol specific type of the control message. For instance, for UNIX fd passing this would be SCM_RIGHTS.

#### Parameters

message | a GSocketControlMessage |

#### Returns

an integer describing the type of control message

Since 2.22

### g_socket_control_message_get_size ()

    gsize
    g_socket_control_message_get_size (GSocketControlMessage *message);

Returns the space required for the control message, not including headers or alignment.

#### Parameters

message | a GSocketControlMessage |

#### Returns

The number of bytes required.

Since 2.22

### g_socket_control_message_serialize ()

    void
    g_socket_control_message_serialize (GSocketControlMessage *message,
                                        gpointer data);

Converts the data in the message to bytes placed in the message.

`data` is guaranteed to have enough space to fit the size returned by `g_socket_control_message_get_size()` on this object.

#### Parameters

message | a GSocketControlMessage |
data | A buffer to write data to |

Since 2.22

## Types and Values

### GSocketControlMessage

    typedef struct _GSocketControlMessage GSocketControlMessage;

Base class for socket-type specific control messages that can be sent and received over GSocket.

## See Also

GSocket.